import numpy as np
import math

# This is the function we will work with for this example
def f(x):
    return np.sqrt(4.0 - x*x)

# Compute an approximation to the integral
# of f(x) from a to b by using Simpson's rule
# with steps of size h = (b-a)/N
def SimpsonArea(a,b,N):
    h = (b-a)/N
    x = np.linspace(a,b-h,N)

    return h/3*(f(x).sum()) + 2*h/3*(f(x+h/2).sum()) - h*f(a)/6 + h*f(b)/6

print("      N  error");
for j in range(3,20,2):
    estimate = SimpsonArea(0.0,2.0,2**j)
    error = math.fabs(math.pi - estimate)
    print("{:>7d}  {:g}".format(2**j,error))
